/******************************************************************************

  Copyright (C), 2001-2014, Hisilicon Tech. Co., Ltd.

 ******************************************************************************
  File Name     : hi_md.h
  Version       : Initial Draft
  Author        : Hisilicon multimedia software (IVE) group
  Created       : 2014/11/10
  Description   : 
  History       :
  1.Date        : 2014/11/10
    Author      : c00211359
    Modification: Created file
******************************************************************************/
#ifndef _HI_MD_H_
#define _HI_MD_H_

#include "hi_ive.h"

#ifdef __cplusplus
#if __cplusplus
extern "C"{
#endif
#endif
/*
* Definition md algorithm mode
*/
typedef enum hiMD_ALG_MODE_E
{
	MD_ALG_MODE_BG	= 0x0,/*Base on background image*/
	MD_ALG_MODE_REF	= 0x1,/*Base on reference image*/

	MD_ALG_MODE_BUTT
}MD_ALG_MODE_E;
/*
* Definition of md attribute
*/
typedef struct hiMD_ATTR_S
{
	MD_ALG_MODE_E		enAlgMode;	/*Md algorithm mode*/
	IVE_SAD_MODE_E		enSadMode;  /*Sad mode*/	
	HI_U16				u16Width;	/*Image width*/
	HI_U16				u16Height;  /*Image height*/
	HI_U16				u16SadThr;	/*Sad thresh*/
	IVE_CCL_CTRL_S		stCclCtrl;  /*Ccl ctrl*/
	IVE_ADD_CTRL_S		stAddCtrl;  /*Add ctrl*/
}MD_ATTR_S;

#ifdef __cplusplus
#if __cplusplus
}
#endif
#endif

#endif/*_HI_MD_H_*/